// Holidays
var holidays = new Array();
// Usage:
// holidays['numberofday shortmonth'] = 'description';
// You can also use 'true' (without ') or '' (with '),
// that will result in no description.
// false instead of true would make sure days aren't seen as holidays
// you could add all days... but that isn't neccesary ^_^
// don't forget to write ' as \'
// PS You don't need to do it in order, but I'd advise you to...

// Modified Usage - Jarrah Muller 3/7/04
// to have he ability to append a new holiday description to one that 
// already exists, use
// var date = '25 Jul' ; var dtxt = 'nothing' ;
//   if (holidays[date] == undefined)
//     {holidays[date] = 
//     dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
// replace '25 Jul' and 'nothing' with whatever is relevant to you
//
// Moving Holidays become much more difficult this way.
// If you need to add moving holidays, use Good Friday as a template for how 
// to set the date after your calculations have been done.

// 2003 USA Holidays listed at www.timeanddate.com
// National Holiday Act Of 1971 or www.immigrationtimes.com/features/cover.htm
// * not implemented
// Jan 1 - New Year's
// Jan 20 - Martin Luther King Day (3rd Monday in January)
// * Feb 12 - Eid-Al-Adha (Islamic)
// Feb 14 - Valentine's Day
// Feb 17 - President's Day (3rd Monday of February)
// * Mar 5 - Muharramn/New Year (Islamic)
// * Apr 17 - First Day Of Passover (Jewish)
// Apr 18 - Good Friday (Christian)
// Apr 20 - Easter Sunday (Christian)
// Apr 21 - Easter Monday (Christian)
// * Apr 23 - Last Day Of Passover (Jewish)
// * May 4 - Prophet's Birthday (Islamic)
// May 11 - Mother's Day (2nd Sunday of May)
// May 26 - Memorial Day (last Monday of May)
// Jun 15 - Father's Day (3rd Sunday of June)
// Jul 4 - Independence Day
// Sep 1 - Labor Day (1st Monday of September)
// * Sep 27 - Rosh Hashana (Jewish)
// * Oct 6 - Yom Kippur (Jewish)
// Oct 13 - Columbus Day (2nd Monday of October), Thanksgiving Day (Canada)
// * Oct 17 - Last Day Of Sukkof (Jewish)
// * Oct 27 - Ramadan begins
// Oct 31 - Halloween
// Nov 11 - Veteran's Day (2nd Monday of November)
// * Nov 21 - Lailat Ul Qadr (Islamic)
// * Nov 26 - Eid-al-Fitr (Islamic)
// Nov 27 - Thanksgiving Day (4th Thursday of November)
// * Dec 20 - First Day Of Chanukah (Jewish)
// Dec 25 - Christmas
// * Dec 27 - Last Day Of Chanukah (Jewish)


// FIXED HOLIDAYS
// always on the same date
var date = '1 Jan' ; var dtxt = 'New year' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '6 Jan' ; var dtxt = 'Epiphany' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '14 Feb' ; var dtxt = 'St Valentine\'s Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '17 Mar' ; var dtxt = 'St Patrick\'s Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '1 Apr' ; var dtxt = 'April Fools Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '4 Jul' ; var dtxt = 'Independence Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '24 Jul' ; var dtxt = 'Pioneer Day (Utah)' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '31 Oct' ; var dtxt = 'Halloween' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '11 Nov' ; var dtxt = 'Veteran\'s Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '25 Dec' ; var dtxt = 'Christmas Day' ; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}

// BIRTHDAYS
var date = '22 Feb' ; var dtxt = 'George Washington\'s Birthday (1732)'; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}
var date = '12 Feb' ; var dtxt = 'Abraham Lincoln\'s Birthday (1809)'; if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}

// MOVING HOLIDAYS
// are different every year
// I hope everything's here, else it takes a lot of work
// Thanks to Bo Johansson for this script
// This routine is called for every day in the calendar


// following variables are to make sure each moving holiday is only writen once. I don't know why these were writen so many times, but the holidays above weren't - Jarrah Muller 3/7/04
// note that 'GoodFr' will apear twice on the line that sets Good Friday, if you add your own in this format, be sure to change both instances, and add the day to the following list
onceOnly = new Array();
onceOnly['GoodFr'] = 0; onceOnly['EastSun'] = 0; onceOnly['afEastSun'] = 0; 
onceOnly['AscD'] = 0; onceOnly['Whits'] = 0; onceOnly['afWhits'] = 0; 
onceOnly['PalmSun'] = 0; onceOnly['EastSat'] = 0; onceOnly['MidSum'] = 0; 
onceOnly['DaySavF'] = 0; onceOnly['DaySavB'] = 0; onceOnly['AllSnts'] = 0; 
onceOnly['Carniv'] = 0; onceOnly['mlkD'] = 0; onceOnly['presD'] = 0;
onceOnly['momD'] = 0; onceOnly['memD'] = 0; onceOnly['popD'] = 0;
onceOnly['laborD'] = 0; onceOnly['colmD'] = 0; onceOnly['thankD'] = 0;

function setVarHolidays(theYear,theMonth) {
  EasterWestern(theYear);

  // old holiday text - Jararh Muller 3/7/04
  //holidays[(efrDay + ' ' + efrMonth)] = 'Good Friday';
  //holidays[(esdDay + ' ' + esdMonth)] = 'Easter Sunday';
  //holidays[(emoDay + ' ' + emoMonth)] = 'day after Easter Sunday';
  //holidays[(athDay + ' ' + athMonth)] = 'Ascension Day';
  //holidays[(whsDay + ' ' + whsMonth)] = 'Whitsunday';
  //holidays[(whmDay + ' ' + whmMonth)] = 'day after Whitsunday';
  var date = (efrDay + ' ' + efrMonth) ; var dtxt = 'Good Friday' ;  if (onceOnly['GoodFr'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['GoodFr'] = 1;}
  var date = (esdDay + ' ' + esdMonth) ; var dtxt = 'Easter Sunday' ;  if (onceOnly['EastSun'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['EastSun'] = 1;}
  var date = (emoDay + ' ' + emoMonth) ; var dtxt = 'day after Easter Sunday' ;  if (onceOnly['afEastSun'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['afEastSun'] = 1;}
  var date = (athDay + ' ' + athMonth) ; var dtxt = 'Ascension Day' ;  if (onceOnly['AscD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['AscD'] = 1;}
  var date = (whsDay + ' ' + whsMonth) ; var dtxt = 'Whitsunday' ;  if (onceOnly['Whits'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['Whits'] = 1;}
  var date = (whmDay + ' ' + whmMonth) ; var dtxt = 'day after Whitsunday' ;  if (onceOnly['afWhits'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['afWhits'] = 1;}
   
  //calculate test thingy, no support for year input yet
  //holidays[(calculateDay( (esdDay + ' ' + esdMonth), -40))] = 'Carnival';
  //holidays[(calculateDay( (esdDay + ' ' + esdMonth), -7))] = 'Palm Sunday';
  //holidays[(calculateDay( (esdDay + ' ' + esdMonth), -1))] = 'Easter Saturday';
  var date = (calculateDay( (esdDay + ' ' + esdMonth), -40)) ; var dtxt = 'Carnival' ;  if (onceOnly['Carniv'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['Carniv'] = 1;}
  var date = (calculateDay( (esdDay + ' ' + esdMonth), -7)) ; var dtxt = 'Palm Sunday' ;  if (onceOnly['PalmSun'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['PalmSun'] = 1;}
  var date = (calculateDay( (esdDay + ' ' + esdMonth), -1)) ; var dtxt = 'Easter Saturday' ;  if (onceOnly['EastSat'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['EastSat'] = 1;}
   //need ash wednesday


// Midsummer day is the Saturday between 20-26 June
//  var testDate = 0;
//
//  for(i = 20; i < 27; ++i) {
//    testDate = new Date(i + ' Jun ' + theYear);
//
//    if( testDate.getDay() == 6) {
//      mssDay = i;
//    }
//  }

  //holidays[(mssDay + ' Jun')] = 'Midsummer day';
//  if (theMonth == "Jun") {
//  var date = (mssDay + ' Jun') ; var dtxt = 'Midsummer day' ;  if (onceOnly['MidSum'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['MidSum'] = 1;}
//  }  


// USA Holidays -- calculate first day by assuming 1st of month on that 
// weekday.  Thus second Sunday is 8th (1st + 1 week*7 days/week)
// Jan - Martin Luther King Day (3rd Monday in January)
  var testDate = 0;
  for(i = 15; i < 22; ++i) {
    testDate = new Date(i + ' Jan ' + theYear);

    if( testDate.getDay() == 1) {
      mlkDay = i;   }  }
  if (theMonth == "Jan") {
    var date = (mlkDay + ' Jan') ; var dtxt = 'Martin Luther King Day' ;  if (onceOnly['mlkD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['mlkD'] = 1;}
  }  
//    holidays[(mlkDay + ' Jan')] = 'Martin Luther King Day';

// Feb - President's Day (3rd Monday of February)
  var testDate = 0;
  for(i = 15; i < 22; ++i) {
    testDate = new Date(i + ' Feb ' + theYear);

    if( testDate.getDay() == 1) {
      presDay = i;    }  }
  if (theMonth == "Feb") {
    var date = (presDay + ' Feb') ; var dtxt = 'President\'s Day' ;  if (onceOnly['presD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['presD'] = 1;}
  }  
//    holidays[(presDay + ' Feb')] = 'President\'s Day';

// May - Mother's Day (2nd Sunday of May)
  var testDate = 0;
  for(i = 8; i < 15; ++i) {
    testDate = new Date(i + ' May ' + theYear);

    if( testDate.getDay() == 0) {
      momDay = i;    }  }
  if (theMonth == "May") {
    var date = (momDay + ' May') ; var dtxt = 'Mother\'s Day' ;  if (onceOnly['momD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['momD'] = 1;}
  }  
//    holidays[(momDay + ' May')] = 'Mother\'s Day';

// May - Memorial Day (last Monday of May)
  var testDate = 0;
  for(i = 24; i <32; ++i) {
    testDate = new Date(i + ' May ' + theYear);

    if( testDate.getDay() == 1) {
      memDay = i;
      if( memDay == 24){memDay=31}      }  }
  if (theMonth == "May") {
    var date = (memDay + ' May') ; var dtxt = 'Memorial Day' ;  if (onceOnly['memD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['memD'] = 1;}
  }  
//    holidays[(memDay + ' May')] = 'Memorial Day';  

// Jun - Father's Day (3rd Sunday of June)
  var testDate = 0;
  for(i = 15; i < 22; ++i) {
    testDate = new Date(i + ' Jun ' + theYear);

    if( testDate.getDay() == 0) {
      popDay = i;    }  }
  if (theMonth == "Jun") {
    var date = (popDay + ' Jun') ; var dtxt = 'Father\'s Day' ;  if (onceOnly['popD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['popD'] = 1;}
  }  
//    holidays[(popDay + ' Jun')] = 'Father\'s Day';

// Sep - Labor Day (1st Monday of September)
  var testDate = 0;
  for(i = 1; i < 8; ++i) {
    testDate = new Date(i + ' Sep ' + theYear);

    if( testDate.getDay() == 1) {
      laborDay = i;    }  }
  if (theMonth == "Sep") {
    var date = (laborDay + ' Sep') ; var dtxt = 'Labor Day' ;  if (onceOnly['laborD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['laborD'] = 1;}
  }  
//    holidays[(laborDay + ' Sep')] = 'Labor Day';

// Oct - Columbus Day (2nd Monday of October), Thanksgiving Day (Canada)
  var testDate = 0;
  for(i = 8; i < 15; ++i) {
    testDate = new Date(i + ' Oct ' + theYear);

    if( testDate.getDay() == 1) {
      colmDay = i;    }  }
  if (theMonth == "Oct") {
    var date = (colmDay + ' Oct') ; var dtxt = 'Columbus Day' ;  if (onceOnly['colmD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['colmD'] = 1;}
  }  
//    holidays[(colmDay + ' Oct')] = 'Columbus Day';

// Nov - Thanksgiving Day (4th Thursday of November)
  var testDate = 0;
  for(i = 22; i < 29; ++i) {
    testDate = new Date(i + ' Nov ' + theYear);

    if( testDate.getDay() == 4) {
      thankDay = i;    }  }
  if (theMonth == "Nov") {
    var date = (thankDay + ' Nov') ; var dtxt = 'Thanksgiving Day' ;  if (onceOnly['thankD'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['thankD'] = 1;}
  }  
//    holidays[(thankDay + ' Nov')] = 'Thanksgiving Day';


  // Daylight savings, turn clocks forward 1 hour - Jarrah Muller
  var testDate = 0;

  for(i = 24; i <32; ++i) {
    testDate = new Date(i + ' Oct ' + theYear);

    if( testDate.getDay() == 0) {
      DSF = i;
    if( DSF == 24){DSF=31}  
    }
  }

  //holidays[(DSF + ' Oct')] = 'Daylight Saving, turn clocks forwards';  
  if (theMonth == "Oct") {
    var date = (DSF + ' Oct') ; var dtxt = 'Daylight Saving, turn clocks forwards' ;  if (onceOnly['DaySavF'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['DaySavF'] = 1;}
  }
  

  // Daylight savings, turn clocks back 1 hour - Jarrah Muller
  var testDate = 0;

  for(i = 24; i < 32; ++i) {
    testDate = new Date(i + ' Mar ' + theYear);

    if( testDate.getDay() == 0) {
      DSB = i;
        if( DSB == 24){DSB=31}    

    }
  }

  //holidays[(DSB + ' Mar')] = 'Daylight Saving, turn clocks backwards';  
  if (theMonth == "Mar") {
    var date = (DSB + ' Mar') ; var dtxt = 'Daylight Saving, turn clocks backwards' ;  if (onceOnly['DaySavB'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['DaySavB'] = 1;}
  }  


// All Saints' day is the Saturday between 31 Oct - 6 Nov
  ahdDay = 31;
  ahdMonth = 'Oct';

  for(i = 1; i < 7; ++i) {
    testDate = new Date(i + ' Nov ' + theYear);

    if( testDate.getDay() == 6) {
      ahdDay = i;
      ahdMonth = 'Nov';
    }
  }

  //holidays[(ahdDay + ' ' + ahdMonth)] = 'All Saints\' day';
  if (theMonth == "Jun") {
    var date = (ahdDay + ' ' + ahdMonth) ; var dtxt = 'All Saints\' day' ;  if (onceOnly['AllSnts'] == 0){if (holidays[date] == undefined){holidays[date] = dtxt;}else{holidays[date] = holidays[date] + '<br>' + dtxt;}onceOnly['AllSnts'] = 1;}
  }
  

}

// Long month names 
// longmonths is used for calendar titles. They don't have to be long, 
// just whatever you would like to display 
// ENGLISH longmonths array
var longmonths = new Array( 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December' );

// the symbols to use at the top of the calendars
// ENGLISH day of week array
var dow = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
// abbreviation of week
var week_ab = 'Wk';
// Date format
// Most used is the "dd month" format, however some languages use the "month dd" format.
// Also your personal preference could be "month dd". Whatever's the case, it's easily
// customizable here...
function date_format(cmdate,longmonth) {
  var format = cmdate + ' ' + longmonth;
  return format;
}
// Weekend format
// 0=sunday, 6=saturday, works self explanatory...
function weekend_format(mDate) {
  return ( ( 0 == mDate.getDay() )  ||  ( 6 == mDate.getDay() ) );
}
// Close window in popupwindows
var close_window = 'Close window';